commit a246543987cbaf05b2040637bee6eb8b570838b3
Author: freddy77 <freddy77>
Date:   Tue Jan 26 13:43:09 2010 +0000

    avoid silly buffer overflow

diff --git a/ChangeLog b/ChangeLog
index a885aff..58245a2 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Tue Jan 26 14:41:18 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* win32/winsetup.c: avoid silly buffer overflow
+
 Tue Jan 26 12:20:56 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* configure.ac include/tds.h src/tds/Makefile.am src/tds/login.c:
 	* src/tds/sspi.c:
@@ -2190,4 +2193,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2955 2010/01/26 11:21:10 freddy77 Exp $
+$Id: ChangeLog,v 1.2956 2010/01/26 13:43:09 freddy77 Exp $
diff --git a/win32/winsetup.c b/win32/winsetup.c
index 8a0b26f..c37384f 100644
--- a/win32/winsetup.c
+++ b/win32/winsetup.c
@@ -396,19 +396,22 @@ ConfigDSN(HWND hwndParent, WORD fRequest, LPCSTR lpszDriver, LPCSTR lpszAttribut
 BOOL INSTAPI
 ConfigDriver(HWND hwndParent, WORD fRequest, LPCSTR lpszDriver, LPCSTR lpszArgs, LPSTR lpszMsg, WORD cbMsgMax, WORD * pcbMsgOut)
 {
+	const char *msg = NULL;
+
 	/* TODO finish ?? */
 	switch (fRequest) {
 	case ODBC_INSTALL_DRIVER:
-		/* FIXME possible buffer overflow */
-		strcpy(lpszMsg, "Hello");
-		*pcbMsgOut = strlen(lpszMsg);
+		msg = "Hello";
 		break;
 	case ODBC_REMOVE_DRIVER:
-		/* FIXME possible buffer overflow */
-		strcpy(lpszMsg, "Goodbye");
-		*pcbMsgOut = strlen(lpszMsg);
+		msg = "Goodbye";
 		break;
 	}
+
+	if (msg && lpszMsg && cbMsgMax > strlen(msg)) {
+		strcpy(lpszMsg, msg);
+		*pcbMsgOut = strlen(msg);
+	}
 	return TRUE;
 }
 

